# CSV Catalog Downloader

## Features

This service allows end-users to download a CSV export of the metadata catalog. Such export is generated by submitting a query to a dedicated endpoint of one of the HTTP APIs exposed by GeoNetwork. As the latter query is typically resolved by GeoNetwork in a few minutes time, this service was initially conceived as a **cache layer**, preventing end-users from waiting for such a considerable amount of time. Beyond acting as a cache layer, this service also performs the following transformations:

* the column separator used by GeoNetwork, `###`, is replaced by a more conventional comma;
* the exported CSV file is encoded either in UTF-8 or WINDOWS-1252 depending on the `User-Agent` header of the incoming requests.

data.grandlyon.com's metadata catalog being refreshed at most once per day, overnight, this service refreshes its cache with the same frequency.

## Dependencies

This service only depends on GeoNetwork.

## Endpoints

The service exposes only one endpoint, `/`, returning a CSV file as attachment.

## Implementation

The service is implemented in the Python language, using [Flask](https://palletsprojects.com/p/flask/) as Web framework, [Gunicorn](https://gunicorn.org/) as WSGI HTTP Server and the [Advanced Python Scheduler](https://apscheduler.readthedocs.io/en/stable/) to schedule daily updates of the cache.
